version: '3'

volumes:
  esdata:

services:
  es:
    image: docker.elastic.co/elasticsearch/elasticsearch:5.4.0
    ports:
      - 9200
    environment:
      - cluster.name=docker-kata
      - transport.host=0.0.0.0
      - http.host=0.0.0.0
      - bootstrap.memory_lock=true
      - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
      - xpack.security.enabled=false
      - discovery.type=single-node
    ulimits:
      memlock:
        soft: -1
        hard: -1
    volumes:
      - esdata:/usr/share/elasticsearch/data
  ldap:
    build:
      context: ldap
    image: users:ldap
    ports:
      - 389:389
    environment:
      SLAPD_PASSWORD: demo_password
      SLAPD_DOMAIN: demo.bti360.com
      SLAPD_ORGANIZATION: BTI360, Inc.
  api:
    build:
      context: user-api
    image: users:api
    ports:
      - 5005:5005
    environment:
      DEBUG_API: "false"
      LDAP_URL: ldap://ldap:389
      LDAP_BASE_DN: dc=demo,dc=bti360,dc=com
      LDAP_BIND_USER_DN: cn=admin,dc=demo,dc=bti360,dc=com
      LDAP_BIND_USER_PASSWORD: demo_password
      CA_CERT: /etc/users/ca.p12
      ES_HOST: es
      ES_CLUSTER_NAME: docker-kata
    volumes:
      - ./user-api/src:/user-api/src
      - ./x509/ca/ca.p12:/etc/users/ca.p12:ro
    links:
      - es
      - ldap
  ui:
    build:
      context: user-ui
    image: users:ui
    volumes:
      - ./user-ui:/user-ui
  proxy:
    build:
      context: nginx
    image: users:proxy
    ports:
      - 8080:80
      - 8443:443
    environment:
      HTTPS_REDIRECT_PORT: 8443
      SERVER_NAME: "localhost proxy"
    volumes:
      - ./x509/server:/etc/nginx/ssl:ro
      - ./x509/ca/ca.crt:/etc/nginx/ca/ca.crt:ro
    links:
      - api
      - ui
  data:
    build:
      context: datagen
    image: users:datagen
    volumes:
      - ./tmp:/random_users
    environment:
      ES_HOST: es:9200
      LDAP_URL: ldap://ldap:389
      LDAP_BIND_USER: cn=admin,dc=demo,dc=bti360,dc=com
      LDAP_BIND_PASSWORD: demo_password
      USER_BASE_DN: ou=users,dc=demo,dc=bti360,dc=com
      ADMIN_GROUP_DN: cn=admins,ou=groups,dc=demo,dc=bti360,dc=com
      USER_GROUP_DN: cn=users,ou=groups,dc=demo,dc=bti360,dc=com
      LOG_LEVEL: INFO
      NUM_USERS: 100
      SERVICE_TIMEOUT: 60
    depends_on:
      - es
      - ldap
    links:
      - es
      - ldap
